#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

print $cgi->headerCode(__("Admin"), "/admin");

print $cgi->menuCode();

# MyNews billboard

print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";

print "<caption class=\"adminformtitle\">\n";
print __("MyNews billboard")."\n";
print "</caption>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformtopleft"></td>'."\n";
print '<td colspan=2 class="adminformtop"></td>'."\n";
print '<td class="adminformtopright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Local site")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="'.$mne->{conf}->{weburl}.'">'.$mne->{conf}->{weburl}."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Distant site")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="'.$mne->{conf}->{mnurl}.'">'.$mne->{conf}->{mnurl}."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

if ($mne->{conf}->{puburl})
{
    print '<tr class="adminformtr">'."\n";
    print '<td class="adminformleft"></td>'."\n";
    print '<td class="adminformlabel">'."\n";
    print __("Public site")."\n";
    print "</td>\n";
    print '<td class="adminformtd">'."\n";
    print '<a href="'.$mne->{conf}->{puburl}.'">'.$mne->{conf}->{puburl}."</a>\n";
    print "</td>\n";
    print '<td class="adminformright"></td>'."\n";
    print "</tr>\n";
}

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Templates")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="templates.cgi">'.MN::Template->getObjectsCount()."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Topics")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="topics.cgi">'.MN::Topic->getObjectsCount()."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("News")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="news.cgi">'.MN::News->getObjectsCount()."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Themes")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="themes.cgi">'.MN::Theme->getObjectsCount()."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Users")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print '<a href="users.cgi">'.MN::User->getObjectsCount()."</a>\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformbottomleft"></td>'."\n";
print '<td colspan=2 class="adminformbottom"></td>'."\n";
print '<td class="adminformbottomright"></td>'."\n";
print "</tr>\n";

print "</table>\n";

print "<p>\n";

# MyNews server information

print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";

print "<caption class=\"adminformtitle\">\n";
print __("MyNews server")."\n";
print "</caption>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformtopleft"></td>'."\n";
print '<td colspan=2 class="adminformtop"></td>'."\n";
print '<td class="adminformtopright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Operating system")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print ucfirst($^O)."\n";
if ($^O eq "linux")
{
    print " ";
    print $mne->getKernelVersion();
}
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

if ($^O eq "linux")
{
    print '<tr class="adminformtr">'."\n";
    print '<td class="adminformleft"></td>'."\n";
    print '<td class="adminformlabel">'."\n";
    print __("Distribution")."\n";
    print "</td>\n";
    print '<td class="adminformtd">'."\n";
    print $mne->getDistribVersion();
    print "</td>\n";
    print '<td class="adminformright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="adminformtr">'."\n";
    print '<td class="adminformleft"></td>'."\n";
    print '<td class="adminformlabel">'."\n";
    print __("CPU")."\n";
    print "</td>\n";
    print '<td class="adminformtd">'."\n";
    print $mne->getCPUInfo();
    print "</td>\n";

    print '<td class="adminformright"></td>'."\n";
    print "</tr>\n";
    print '<tr class="adminformtr">'."\n";
    print '<td class="adminformleft"></td>'."\n";
    print '<td class="adminformlabel">'."\n";
    print __("Memory")."\n";
    print "</td>\n";
    print '<td class="adminformtd">'."\n";
    print $mne->getMemInfo();
    print "</td>\n";
    print '<td class="adminformright"></td>'."\n";
    print "</tr>\n";
}

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Webserver")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print "$ENV{SERVER_SOFTWARE}\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Database")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
if ($mne->{conf}->{backends}->{default}->{type} eq "mysql")
{
    print "MySQL ";
}
elsif ($mne->{conf}->{backends}->{default}->{type} eq "pgsql")
{
    print "PostgreSQL ";
}
elsif ($mne->{conf}->{backends}->{default}->{type} eq "oracle")
{
    print "Oracle ";
}
print $mne->getDBVersion("default");
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformleft"></td>'."\n";
print '<td class="adminformlabel">'."\n";
print __("Perl")."\n";
print "</td>\n";
print '<td class="adminformtd">'."\n";
print "$]\n";
print "</td>\n";
print '<td class="adminformright"></td>'."\n";
print "</tr>\n";

print '<tr class="adminformtr">'."\n";
print '<td class="adminformbottomleft"></td>'."\n";
print '<td colspan=2 class="adminformbottom"></td>'."\n";
print '<td class="adminformbottomright"></td>'."\n";
print "</tr>\n";

print "</table>\n";

print $cgi->footerCode();
