#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my @navitems = (__("Admin"), "/admin", __("News"), "/admin/news.cgi");
if ($cgi->{template})
{
    push @navitems, $cgi->{template}, "/admin/news.cgi?template=$cgi->{template}";
}
elsif ($cgi->{topic} && ($cgi->{topic} =~ /^([^_]+)_(.*)$/))
{
    push @navitems, $1, "/admin/news.cgi?template=$1";
    push @navitems, $2, "/admin/news.cgi?topic=$cgi->{topic}";
}
elsif ($cgi->{date})
{
    push @navitems, $cgi->{date}, "/admin/news.cgi?date=$cgi->{date}";
}
print $cgi->headerCode(@navitems);

print $cgi->menuCode();

if ($cgi->{delete})
{
    my @ids = split(/\0/, $cgi->{id});
    if (scalar(@ids))
    {
	my $res = MN::News->execSQL("delete from mnnews where id in ('".join("','", @ids)."')");
    }
}

my $filter = "";
if ($cgi->{template})
{
    $filter = "template='$cgi->{template}'";
}
elsif ($cgi->{topic})
{
    $filter = "topic='$cgi->{topic}'";
}
elsif ($cgi->{date})
{
    $filter = "date='$cgi->{date}'";
}
my $nbn = MN::News->getObjectsCount($filter);
my $npp = 20;
my $fbp = ($nbn / $npp);
my $nbp = int($fbp);
if ($nbp < $fbp || $nbp == 0) { $nbp++ ; }
my $offset = 0;
if ($cgi->{page} > 1)
{
    $offset = ($cgi->{page} - 1) * $npp;
}
my @nnews = MN::News->getObjects($filter, "date desc, crtime desc", $npp, $offset);

print '<script language="JavaScript" type="text/javascript">'."\n";
print "<!--\n";
print "function checknews(value)\n";
print "{\n";
print "    for (i = 0; i < window.document.news.elements.length; i++) {\n";
print "        window.document.news.elements[i].checked = value;\n";
print "    }\n";
print "}\n";
print "//-->\n";
print "</script>\n";
print "<form method=\"post\">\n";
print "<div class=\"adminpage\">\n";
print '<div class="adminpagelabel">'.__("Page")."</div>\n";
print '<select class="adminpageselect" name="page" onchange="form.submit();">'."\n";
my $i;
for ($i = 1; $i <= $nbp; $i++)
{
    print '<option value="'.$i.'"';
    if ($i == $cgi->{page})
    {
	print " selected";
    }
    print '>'.$i."\n";
}
print "</select>\n";
print "&nbsp;";
printf(__("of %d"), $nbp);
print "</div>\n";
print '<input class="adminformbutton" type="submit" value="'.__("Select all").'" onclick="checknews(1);return false">'."\n";
print '<input class="adminformbutton" type="submit" value="'.__("Unselect all").'" onclick="checknews(0);return false">'."\n";
if ($cgi->{template})
{
    print '<input type="hidden" name="template" value="'.$cgi->{template}.'">'."\n";
}
elsif ($cgi->{topic})
{
    print '<input type="hidden" name="topic" value="'.$cgi->{topic}.'">'."\n";
}
elsif ($cgi->{date})
{
    print '<input type="hidden" name="date" value="'.$cgi->{date}.'">'."\n";
}
print "</form>\n";
print "<br clear=all>\n";
print "<form method=\"post\" name=\"news\">\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrtopleft">'."</td>\n";
print '<td class="admintbrtop">'."</td>\n";
print '<td class="admintbrtopright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrleft">'."</td>\n";
print '<td class="admintbr">'."\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
print '<tr class="adminheadertr">'."\n";
print '<td class="adminnumbertd2" title="';
printf(__("%d news"), $nbn);
print '">'."#"."</td>\n";
print '<td class="adminheadertd">'.__("News")."</td>\n";
if ($cgi->{template})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="news.cgi" title="'.__("All templates").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Template");
if ($cgi->{template})
{
    print '</a>';
}
print "</td>\n";
if ($cgi->{topic})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="news.cgi" title="'.__("All topics").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Topic");
if ($cgi->{topic})
{
    print '</a>';
}
print "</td>\n";
if ($cgi->{date})
{
    print '<td class="selectedadminheadertd">';
    print '<a href="news.cgi" title="'.__("All dates").'">';
}
else
{
    print '<td class="adminheadertd">';
}
print __("Date");
if ($cgi->{date})
{
    print '</a>';
}
print "</td>\n";
print "</tr>\n";
my $row = "odd";
my $news;
my $tmpl;
my $topic;
my $n = $offset;
foreach $news (@nnews)
{
    print '<tr class="admin'.$row.'tr">'."\n";

    # number
    print '<td class="adminnumbertd">';
    $n++;
    print $n."\n";
    print "</td>\n";

    # news
    print '<td class="admin'.$row.'td">';
    print '<input type="checkbox"  class="adminformcheckbox" name="id" value="'.$news->{id}.'">';
    print '<a href="/news.cgi?id='.$news->{id}.'">'.$news->{name}."</a>\n";
    print "</td>\n";

    # template
    print '<td class="admin'.$row.'td">';
    $tmpl = $news->getTemplate();
    if ($tmpl)
    {
	print '<a href="news.cgi?template='.$tmpl->{id}.'">'.$tmpl->{name}."</a>\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";

    # topic
    print '<td class="admin'.$row.'td">';
    $topic = $news->getTopic();
    if ($topic)
    {
	print '<a href="news.cgi?topic='.$topic->{id}.'">'.$topic->{name}."</a>\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";

    # date
    print '<td class="admin'.$row.'td">';
    print '<a href="news.cgi?date='.$news->{date}.'">'.$news->getDate()."</a>\n";
    print "</td>\n";

    print "</tr>\n";
    $row = $row eq "odd" ? "even" : "odd";
}
print "</table>\n";
print "</td>\n";
print '<td class="admintbrright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrbottomleft">'."</td>\n";
print '<td class="admintbrbottom">'."</td>\n";
print '<td class="admintbrbottomright">'."</td>\n";
print "</tr>\n";
print "</table>\n";

print "<p>\n";
print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete selected news?").">\n";
if ($cgi->{template})
{
    print '<input type="hidden" name="template" value="'.$cgi->{template}.'">'."\n";
}
elsif ($cgi->{topic})
{
    print '<input type="hidden" name="topic" value="'.$cgi->{topic}.'">'."\n";
}
elsif ($cgi->{date})
{
    print '<input type="hidden" name="date" value="'.$cgi->{date}.'">'."\n";
}
print "</form>\n";

print $cgi->footerCode();
