#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my $tmpl;

if ($cgi->{delete} && $cgi->{id})
{
    my $template = MN::Template->getTemplate($cgi->{id});
    if ($template)
    {
	$template->delete();
    }
    $cgi->{id} = 0;
}
elsif (!$cgi->{cancel} && $cgi->{custom})
{
    my $template = MN::Template->getTemplate($cgi->{custom});

    if ($cgi->{change})
    {
	rename("$mne->{conf}->{webdir}/img/templates/_$ENV{REMOTE_USER}_.png", "$mne->{conf}->{webdir}/img/templates/$template->{id}.png");
	chmod(0664, "$mne->{conf}->{webdir}/img/templates/$template->{id}.png");
    }
    else
    {
	print $cgi->headerCode(__("Admin"), "/admin", __("Templates"), "/admin/templates.cgi", $cgi->{custom}, "/admin/templates.cgi?id=$cgi->{custom}");
	
	print $cgi->menuCode();
	
	if ($cgi->{iconfile})
	{
	    $cgi->writeFileUpload("iconfile", "$mne->{conf}->{webdir}/img/templates/_$ENV{REMOTE_USER}_.png");
	}
	print "<form method=\"post\" enctype=\"multipart/form-data\">\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";

	print "<caption class=\"adminformtitle\">\n";
	print $cgi->{custom}."\n";
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=4 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Old icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $template->getCode("menu");
	print "</td>\n";
	print '<td class="adminformlabel">'."\n";
	print __("New icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	if ($cgi->{try} && -e "$mne->{conf}->{webdir}/img/templates/_$ENV{REMOTE_USER}_.png")
	{
	    print "<div class=\"newstemplatemenu\">\n";
	    print "<img src=\"$mne->{conf}->{weburl}/img/templates/_$ENV{REMOTE_USER}_.png\">\n";
	    print "</div>\n";
	}
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Icon file")."\n";
	print "</td>\n";
	print '<td colspan=2 class="adminformtd">'."\n";
	print '<input class="adminforminput" type="file" name="iconfile">'."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminformbutton" type="submit" name="try" value="'.__("Try").'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td colspan=4 class="adminformtd">'."\n";
	print '<hr class="adminformseparator">'."\n";
	if ($cgi->{try})
	{
	    print '<input class="adminformbutton" type="submit" name="change" value="'.__("Submit").'">'."\n";
	}
	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	
	print '<input type="hidden" name="custom" value="'.$cgi->{custom}.'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=4 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	
	print "<form>\n";
	print $cgi->footerCode();
	exit;
    }
}
elsif ($cgi->{export} && $cgi->{id})
{
    $tmpl = MN::Template->getTemplate($cgi->{id});
    print $cgi->exportCode($tmpl->{id}.'.mnt');
    print $tmpl->getExportCode();
    exit();
}
elsif ($cgi->{reload})
{
    $tmpl = MN::Template->getTemplate($cgi->{reload});
    my $res = $tmpl->getTemplateIcon();
    if ($res)
    {
	$cgi->setAlert("Error when reloading icon from website (%s)", $res);
    }
    else
    {
	$cgi->setAlert("Icon sucessfully reloaded from website");
    }
}
elsif ($cgi->{swst})
{
    $tmpl = MN::Template->getTemplate($cgi->{swst});
    $tmpl->modifyAttribute("active", 1 - $tmpl->{active});
}
elsif ($cgi->{update})
{
    my $id = $cgi->{mnid} || $cgi->{update};

    my @tmpls = MN::Template->getObjects("mnid = '$id'");
    my $active;
    if (scalar(@tmpls))
    {
	foreach $tmpl (@tmpls)
	{
	    $active = $tmpl->{active};
	    $tmpl->updateFromMyNews();
	    $tmpl->{active} = $active;
	    $tmpl->modify();
	}
    }
    else
    {
	$tmpl = new MN::Template();
	$tmpl->{mnid} = $id;
	$tmpl->updateFromMyNews();
	$tmpl->{active} = 0;
	$tmpl->add();
    }
    $cgi->{id} = 0;
    $cgi->{check} = 1;
}

my @extra = ();
if ($cgi->{id})
{
    push @extra, $cgi->{id}, "/admin/templates.cgi?id=$cgi->{id}";
}
elsif ($cgi->{new})
{
    push @extra, __("New template"), "/admin/templates.cgi?new=1";
}

print $cgi->headerCode(__("Admin"), "/admin", __("Templates"), "/admin/templates.cgi", @extra);

print $cgi->menuCode();

if (!$cgi->{cancel} && ($cgi->{id} || $cgi->{new} || $cgi->{import}))
{
    if ($cgi->{id})
    {
	$tmpl = MN::Template->getObject($cgi->{id});
    }
    if ($cgi->{create})
    {
	if ($tmpl)
	{
	    $cgi->error("Template %s already exists", $cgi->{id});
	}
	$tmpl = new MN::Template();
	$tmpl->updateFrom($cgi);
	$tmpl->add();
    }
    elsif ($cgi->{modify})
    {
	if (!$tmpl)
	{
	    $cgi->error("Template %s doesn't exist", $cgi->{id});
	}
	$tmpl->updateFrom($cgi);
	$tmpl->modify();
    }
    else
    {
	if (!$tmpl)
	{
	    $tmpl = new MN::Template();
	}
	if ($cgi->{import} && $cgi->{mntfile})
	{
	    my $mntfile = "/tmp/$ENV{REMOTE_USER}.mnt";
	    $cgi->writeFileUpload("mntfile", $mntfile);
	    $tmpl->updateFromFile($mntfile);
	    unlink($mntfile);
	}
	elsif ($cgi->{test})
	{
	    $tmpl->updateFrom($cgi);
	    $tmpl->setCurrent();
	}
	print "<form method=\"post\" enctype=\"multipart/form-data\">\n";

	print "<table border=0 cellspacing=10 cellpadding=0>\n";
	print "<tr align=\"right\" valign=\"top\">\n";

	# general
	print "<td>\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print "<caption class=\"adminformtitle\">\n";
	print __("General")."\n";
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=2 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Id")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input type="text" name="id" value="'.$tmpl->{id}.'" size="50"';
	if ($cgi->{id})
	{
	    print 'class="roadminforminput" readonly onfocus="blur();"';
	}
	else
	{
	    print 'class="adminforminput"';
	}
	print ">\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
		
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Name")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="name" value="'.$cgi->unquote($tmpl->{name}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Comment")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="comment" value="'.$cgi->unquote($tmpl->{comment}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("URL")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="url" value="'.$cgi->unquote($tmpl->{url}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Language")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $cgi->langSelectorCode($tmpl->{lang}, 0, "admin");
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("MyNews id")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="mnid" value="'.$cgi->unquote($tmpl->{mnid}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Last update")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="roadminforminput" readonly onfocus="blur();" type="text"  value="'.$cgi->unquote($tmpl->getLastUpdate()).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=2 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	print "</td>\n";

	# news
	print "<td>\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print "<caption class=\"adminformtitle\">\n";
	print __("News")."\n";
	print "</caption>\n";
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=2 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";
		
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Start")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_news_start" value="'.$cgi->unquote($tmpl->{rx_news_start}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("End")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_news_end" value="'.$cgi->unquote($tmpl->{rx_news_end}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Id")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_news_id" value="'.$cgi->unquote($tmpl->{rx_news_id}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Name")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_news_name" value="'.$cgi->unquote($tmpl->{rx_news_name}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Date")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_news_date" value="'.$cgi->unquote($tmpl->{rx_news_date}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("First line")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_news_first" value="'.$cgi->unquote($tmpl->{rx_news_first}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Last line")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_news_last" value="'.$cgi->unquote($tmpl->{rx_news_last}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=2 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	print "</td>\n";

	print "</tr>\n";

	print "<tr align=\"right\" valign=\"top\">\n";

	# links
	print "<td>\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print "<caption class=\"adminformtitle\">\n";
	print __("Links")."\n";
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=2 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";
		
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("News")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="link_news" value="'.$cgi->unquote($tmpl->{link_news}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Template icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="icon_url" value="'.$cgi->unquote($tmpl->{icon_url}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Topic icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="link_icon" value="'.$cgi->unquote($tmpl->{link_icon}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=2 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	print "</td>\n";

	# topic
	print "<td>\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print "<caption class=\"adminformtitle\">\n";
	print __("Topic")."\n";
	print "</caption>\n";
		
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=2 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Id")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_topic_id" value="'.$cgi->unquote($tmpl->{rx_topic_id}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Name")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_topic_name" value="'.$cgi->unquote($tmpl->{rx_topic_name}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="rx_topic_icon" value="'.$cgi->unquote($tmpl->{rx_topic_icon}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=2 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	print "</td>\n";

	print "</tr>\n";

	print "<tr align=\"right\" valign=\"top\">\n";

	# search
	print "<td>\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print "<caption class=\"adminformtitle\">\n";
	print __("Search")."\n";
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";
		
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformtd">'."\n";
	print '<textarea class="adminformtextarea" name="rx_search_strings" rows="8" cols="40">'."\n";
	print $cgi->unquote($tmpl->{rx_search_strings});
	print "</textarea>\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	
	print "</tr>\n";

	print "</table>\n";
	print "</td>\n";

	# replace
	print "<td align=\"left\">\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print "<caption class=\"adminformtitle\">\n";
	print __("Replace")."\n";
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";
		
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformtd">'."\n";
	print '<textarea class="adminformtextarea" name="rx_replace_strings" rows="8" cols="40">'."\n";
	print $cgi->unquote($tmpl->{rx_replace_strings});
	print "</textarea>\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";

	print "</table>\n";
	print "</td>\n";

	print "</tr>\n";

	print "</table>\n";

	print '<hr class="adminformseparator">'."\n";

	print '<div class="import">'."\n";
	print '<div class="importlabel">'.__(".mnt file")."</div>\n";
	print '<input class="importinput" type="file" name="mntfile">'."\n";
	print '<input class="importbutton" type="submit" name="import" value="'.__("Import").'">'."\n";
	print "</div>\n";

	print '<hr class="adminformseparator">'."\n";
	
	if ($cgi->{id})
	{
	    print '<input class="adminformbutton" type="submit" name="test" value="'.__("Test").'">'."\n";
	    print '<input class="adminformbutton" type="submit" name="modify" value="'.__("Modify").'">'."\n";
	    print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete template %s?", $cgi->{id}).">\n";
	    print '<input class="adminformbutton" type="submit" name="export" value="'.__("Export").'">'."\n";
	    if ($tmpl->{mnid})
	    {
		print '<input class="adminformbutton" type="submit" name="update" value="'.__("Update from MyNews").'">'."\n";
	    }
	}
	else
	{
	    print '<input class="adminformbutton" type="submit" name="create" value="'.__("Create").'">'."\n";
	}

	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	
	if ($cgi->{test})
	{
	    print '<input type="hidden" name="cache" value="1">'."\n";
	}

	print "</form>\n";

	if ($cgi->{test})
	{
	    print "<br clear=all>\n";
	    print "<hr class=\"adminformseparator\">\n";
	    my $nnews = eval('$tmpl->getNews(0,$cgi->{test},$cgi->{cache})');
	    if ($@)
	    {
		print "<div class=\"error\">$@</div>\n";
	    }
	    elsif ($nnews)
	    {
		my $news;
		my $i = 1;
		foreach $news (reverse @{$nnews})
		{
		    $news->extract();
		    print $news->getCode($i++, "", "", 1);
		}
	    }
	    print "<hr class=\"adminformseparator\">\n";
	}

	print $cgi->footerCode();
	exit;
    }
}

my @tmpls = MN::Template->getObjects("", "id");
foreach $tmpl (@tmpls)
{
    $tmpl->setCurrent();
}
my @tmpls2;
my $nbt = scalar(@tmpls);
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
if ($cgi->{check})
{
    print "<caption class=\"admintbtitle\">\n";
    print __("Check MyNews updates");
    print "</caption>\n";
    MN::Template->getMyNewsUpdates();
    @tmpls2 = MN::Template->getNewTemplates();
    $nbt += scalar(@tmpls2);
}
print '<tr class="admintbr">'."\n";
print '<td class="admintbrtopleft">'."</td>\n";
print '<td class="admintbrtop">'."</td>\n";
print '<td class="admintbrtopright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrleft">'."</td>\n";
print '<td class="admintbr">'."\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
print '<tr class="adminheadertr">'."\n";
print '<td class="adminnumbertd2" title="';
if ($nbt > 1)
{
    printf(__("%d templates"), $nbt);
}
else
{
    printf(__("%d template"), $nbt);
}
print '">'."#"."</td>\n";
print '<td class="adminheadertd">'.__("Id")."</td>\n";
print '<td class="adminheadertd">'.__("Status")."</td>\n";
if (!$cgi->{check})
{
    print '<td class="adminheadertd">'.__("Icon")."</td>\n";
    print '<td class="adminheadertd">'.__("News")."</td>\n";
}
print "</tr>\n";
my $row = "odd";
my $n = 0;
foreach $tmpl (@tmpls)
{
    print '<tr class="admin'.$row.'tr">'."\n";

    # number
    print '<td class="adminnumbertd">';
    $n++;
    print $n."\n";
    print "</td>\n";

    # id
    print '<td class="admin'.$row.'td">';
    print "<a href=\"templates.cgi?id=$tmpl->{id}\">$tmpl->{id}</a>\n";
    print "</td>\n";

    # status
    print '<td class="admin'.$row.'td">';
    if ($cgi->{check})
    {
	print $tmpl->getUpdateCode();
    }
    else
    {
	print "<a href=\"templates.cgi?swst=$tmpl->{id}\">".$tmpl->getStatusCode()."</a>\n";
    }
    print "</td>\n";

    if (!$cgi->{check})
    {
	# icon
	print '<td class="admin'.$row.'td">';
	print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\">\n<tr>\n";
	print "<td>".$tmpl->getCode("admin", $tmpl->{icon_url})."</td>\n";
	print "<td>\n";
	if ($tmpl->{icon_url})
	{
	    print '<a href="templates.cgi?reload='.$tmpl->{id}.'"><div class="reload" title="'.__("Reload icon from website").'"></div></a><br>'."\n";
	}
	print '<a href="templates.cgi?custom='.$tmpl->{id}.'"><div class="custom2" title="'.__("Customize icon").'"></div></a>'."\n";
	print "</td>\n";
	print "</tr></table>\n";
	print "</td>\n";
	print '<td align="right" class="admin'.$row.'td">';
	print "<a href=\"news.cgi?template=$tmpl->{id}\">".MN::News->getObjectsCount("template='$tmpl->{id}'")."</a>";
	print "</td>\n";
    }

    print "</tr>\n";
    $row = $row eq "odd" ? "even" : "odd";
}
if ($cgi->{check})
{
    my $msg = __("Download");
    foreach $tmpl (@tmpls2)
    {
	print '<tr class="admin'.$row.'tr">'."\n";
	
	# number
	print '<td class="adminnumbertd">';
	$n++;
	print $n."\n";
	print "</td>\n";

	# id
	print '<td class="admin'.$row.'td">';
	print "<a href=\"$mne->{conf}->{mnurl}/templates/template.php?id=$tmpl\">$tmpl</a>\n";
	print "</td>\n";
	
	# status
	print '<td class="admin'.$row.'td">';
	print "<a href=\"templates.cgi?update=$tmpl\">\n";
	print "<div class=\"statusnew\" title=\"$msg\">\n";
	print "<img class=\"imgstatusnew\" src=\"$mne->{conf}->{weburl}/img/new.png\" alt=\"$msg\" title=\"$msg\" border=0>\n";
	print "</div>\n";
	print "</a>\n";
	print "</td>\n";
	print "</tr>\n";
	$row = $row eq "odd" ? "even" : "odd";
    }
}
print "</table>\n";
print "</td>\n";
print '<td class="admintbrright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrbottomleft">'."</td>\n";
print '<td class="admintbrbottom">'."</td>\n";
print '<td class="admintbrbottomright">'."</td>\n";
print "</tr>\n";
print "</table>\n";

print "<p>\n";
print "<form method=\"post\">\n";
if ($cgi->{check})
{
    print '<input class="adminformbutton" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
}
else
{
    print '<input class="adminformbutton" type="submit" name="new" value="'.__("New template").'">'."\n";
    print '<input class="adminformbutton" type="submit" name="check" value="'.__("Check MyNews updates").'">'."\n";
}
print "</form>\n";

print $cgi->footerCode();
