#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my $theme;

if ($cgi->{test} && $cgi->{id})
{
    $cgi->getUser()->{testtheme} = 1;
    open(CSS, ">$mne->{conf}->{webdir}/css/themes/$ENV{REMOTE_USER}.css");
    print CSS $cgi->{css};
    close(CSS);
    $theme = MN::Theme->getTheme($cgi->{id});
    $theme->{css} = $cgi->{css};
}
elsif ($cgi->{delete} && $cgi->{id})
{
    my $theme = MN::Theme->getTheme($cgi->{id});
    if ($theme)
    {
	$theme->delete();
    }
    $cgi->{id} = 0;
}
elsif ($cgi->{export} && $cgi->{id})
{
    $theme = MN::Theme->getTheme($cgi->{id});
    print $cgi->exportCode($theme->{id}.'.thm');
    print $theme->getBinCode();
    exit();
}

my @extra = ();
if ($cgi->{id})
{
    push @extra, $cgi->{id}, "/admin/themes.cgi?id=$cgi->{id}";
}
elsif ($cgi->{new})
{
    push @extra, __("New theme"), "/admin/themes.cgi?new=1";
}
print $cgi->headerCode(__("Admin"), "/admin", __("Themes"), "/admin/themes.cgi", @extra);

print $cgi->menuCode();
if ($cgi->{id} && $cgi->{imgfile} && $cgi->{imgfile} =~ /([^\/\\]+\.(gif|jpe?g|png))$/i)
{
    $cgi->writeFileUpload("imgfile", "$mne->{conf}->{webdir}/css/themes/$cgi->{id}/$1");
}
elsif ($cgi->{id} && $cgi->{delimg})
{
    unlink("$mne->{conf}->{webdir}/css/themes/$cgi->{id}/$cgi->{delimg}");
}
elsif ($cgi->{update})
{
    my $id = $cgi->{mnid} || $cgi->{update};

    my @themes = MN::Theme->getObjects("mnid = '$id'");
    if (scalar(@themes))
    {
	foreach $theme (@themes)
	{
	    $theme->updateFromMyNews();
	    $theme->modify();
	}
    }
    else
    {
	$theme = new MN::Theme();
	$theme->{mnid} = $id;
	$theme->updateFromMyNews();
	$theme->add();
    }
    $cgi->{id} = 0;
    $cgi->{check} = 1;
}

if (!$cgi->{cancel} && ($cgi->{id} || $cgi->{new} || $cgi->{import}))
{
    my $thdir;
    if ($cgi->{id})
    {
	$thdir = "$mne->{conf}->{webdir}/css/themes/$cgi->{id}";
	$theme = MN::Theme->getTheme($cgi->{id});
    }
    if ($cgi->{create})
    {
	if ($theme)
	{
	    $cgi->error("Theme %s already exists", $cgi->{id});
	}
	$theme = new MN::Theme();
	$theme->updateFrom($cgi);
	$theme->add();
	$theme->writeCSS($cgi->{mode});
    }
    elsif ($cgi->{modify})
    {
	if (!$theme)
	{
	    $cgi->error("Theme %s doesn't exist", $cgi->{id});
	}
	$theme->updateFrom($cgi);
	$theme->modify();
	$theme->writeCSS($cgi->{mode});
    }
    else
    {
	if ($theme)
	{
	    if ($cgi->{import} && $cgi->{thmfile})
	    {
		my $thmfile = "/tmp/$ENV{REMOTE_USER}.thm";
		$cgi->writeFileUpload("thmfile", $thmfile);
		$theme->updateFromBin($thmfile);
		unlink($thmfile);
	    }
	    if (!$theme->{css})
	    {
		$theme->readCSS($cgi->{mode});
	    }
	}
	else
	{
	    $theme = new MN::Theme();
	}
	print "<form method=\"post\" enctype=\"multipart/form-data\">\n";
	
	print "<table border=0 cellspacing=10 cellpadding=0>\n";
	print "<tr valign=\"top\">\n";
	
	# general
	print "<td>\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	
	print "<caption class=\"adminformtitle\">\n";
	print __("General")."\n";
	print "</caption>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=2 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Id")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input type="text" name="id" value="'.$cgi->{id}.'" size="30"';
	if ($cgi->{id})
	{
	    print 'class="roadminforminput" readonly onfocus="blur();"';
	}
	else
	{
	    print 'class="adminforminput"';
	}
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Name")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="name" value="'.$cgi->unquote($theme->{name}).'" size="30">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Comment")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="comment" value="'.$cgi->unquote($theme->{comment}).'" size="30">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("MyNews id")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="mnid" value="'.$cgi->unquote($theme->{mnid}).'" size="30">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Last update")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="roadminforminput" readonly onfocus="blur();" type="text"  value="'.$cgi->unquote($theme->getLastUpdate()).'" size="30">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=2 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	print "</td>\n";
	
	# images
	print "<td>\n";
	if ($cgi->{id})
	{
	    print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	    
	    print "<caption class=\"adminformtitle\">\n";
	    print __("Images")."\n";
	    print "</caption>\n";

	    print '<tr class="adminformtr">'."\n";
	    print '<td class="adminformtopleft"></td>'."\n";
	    print '<td colspan=3 class="adminformtop"></td>'."\n";
	    print '<td class="adminformtopright"></td>'."\n";
	    print "</tr>\n";
	    
	    print '<tr class="adminformtr">'."\n";
	    print '<td class="adminformleft"></td>'."\n";
	    print '<td class="adminformlabel">'."\n";
	    print __("Image file")."\n";
	    print "</td>\n";
	    print '<td class="adminformtd">'."\n";
	    print '<input type="file" name="imgfile" class="adminformfile">'."\n";
	    print '</td>'."\n";
	    print '<td class="adminformtd">'."\n";
	    print '<input type="submit" name="import" class="adminformbutton" value="'.__("Import").'">'."\n";
	    print "</td>\n";
	    print '<td class="adminformright"></td>'."\n";
	    print "</tr>\n";

	    print '<tr class="adminformtr">'."\n";
	    print '<td class="adminformleft"></td>'."\n";
	    print '<td class="adminformtd" colspan=3>'."\n";
	    my @files = ();
	    opendir(DIR, $thdir);
	    my $file;
	    while ($file = readdir(DIR))
	    {
		if ($file =~ /^\./)
		{
		    next;
		}
		elsif ($file =~ /\.(gif|jpe?g|png)$/i)
		{
		    push @files, $file;
		}
	    }
	    closedir(DIR);
	    foreach $file (sort @files)
	    {
		print '<a class="themeimage" href="themes.cgi?id='.$cgi->{id}.'&delimg='.$file.'" '.$cgi->confirmCode("Do you really want to delete image %s?", $file).'><img class="themeimage" src="/css/themes/'.$cgi->{id}.'/'.$file.'" alt="'.$file.'" title="'.$file.'" border=0></a>';
	    }
	    print "</td>\n";
	    print '<td class="adminformright"></td>'."\n";
	    print "</tr>\n";

	    print '<tr class="adminformtr">'."\n";
	    print '<td class="adminformbottomleft"></td>'."\n";
	    print '<td colspan=3 class="adminformbottom"></td>'."\n";
	    print '<td class="adminformbottomright"></td>'."\n";
	    print "</tr>\n";

	    print "</table>\n";
	}
	else
	{
	    print "&nbsp";
	}
	print "</td>\n";
	print "</tr>\n";
	
	print "<tr valign=\"top\">\n";
	
	# CSS
	print "<td colspan=2>\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	
	print "<caption class=\"adminformtitle\">\n";
	print __("CSS")."\n";
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=2 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Mode")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<select class="adminformselect" name="mode" onchange="form.submit();">'."\n";
	print '<option value="0">'.__("Screen")."\n";
	print '<option value="1"';
	if ($cgi->{mode})
	{
	    print " selected";
	}
	print '>'.__("Printer")."\n";
	print "</select>\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td  colspan=2 class="adminformtd">'."\n";
	print '<textarea class="adminformtextarea" name="css" rows="20" cols="80">'."\n";
	print $theme->{css};
	print "</textarea>\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=2 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	
	print "</td>\n";
	print "</tr>\n";
	print "</table>\n";
	
	print '<hr class="adminformseparator">'."\n";

	print '<div class="import">'."\n";
	print '<div class="importlabel">'.__(".thm file")."</div>\n";
	print '<input class="importinput" type="file" name="thmfile">'."\n";
	print '<input class="importbutton" type="submit" name="import" value="'.__("Import").'">'."\n";
	print "</div>\n";

	print '<hr class="adminformseparator">'."\n";


	if ($cgi->{id})
	{
	    if (!$cgi->{mode})
	    {
		print '<input class="adminformbutton" type="submit" name="test" value="'.__("Test").'">'."\n";
	    }
	    print '<input class="adminformbutton" type="submit" name="modify" value="'.__("Modify").'">'."\n";
	    print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete theme %s?", $cgi->{id}).">\n";
	    print '<input class="adminformbutton" type="submit" name="export" value="'.__("Export").'">'."\n";
	    if ($theme->{mnid})
	    {
		print '<input class="adminformbutton" type="submit" name="update" value="'.__("Update from MyNews").'">'."\n";
	    }

	}
	else
	{
	    print '<input class="adminformbutton" type="submit" name="create" value="'.__("Create").'">'."\n";
	}

	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	
	print "</form>\n";

	if ($cgi->{test})
	{
	    my $condition;
	    my $user = $cgi->getUser();
	    if ($user)
	    {
		$condition = $user->getSubCondition() || "";
	    }
	    my @nnews = MN::News->getObjects($condition, "date desc, crtime desc", 1);
	    if (!scalar(@nnews))
	    {
		@nnews = MN::News->getObjects("", "date desc, crtime desc", 1);
	    }
	    my $news = shift @nnews;
	    print '<hr class="adminformseparator">'."\n";

	    print $news->getCode(1);

	    print '<hr class="adminformseparator">'."\n";

	    print '<table border=0 cellspacing=0 cellpadding=0>'."\n";
	    print "<tr>\n";
	    print "<td class=\"menutd\">\n";
	    my $tmpl = $news->getTemplate();
	    print '<table border=0 cellpadding=0 cellspacing=0 class="netemetb">'."\n";
	    print '<tr class="netemetr">'."\n";
	    print '<td class="netemetopleft"></td>'."\n";
	    print '<td class="netemetop"></td>'."\n";
	    print '<td class="netemetopright"></td>'."\n";
	    print "</tr>\n";
	    print '<tr class="netemetr">'."\n";
	    print '<td class="netemeleft"></td>'."\n";
	    print '<td class="netemetd">'."\n";
	    print "<div class=\"newstemplatesmenu\">\n";
	    print $tmpl->getCode("menu");
	    print "</div>\n";
	    print "</td>\n";
	    print '<td class="netemeright"></td>'."\n";
	    print "</tr>\n";
	    print '<tr class="netemetr">'."\n";
	    print '<td class="netemebottomleft"></td>'."\n";
	    print '<td class="netemebottom"></td>'."\n";
	    print '<td class="netemebottomright"></td>'."\n";
	    print "</tr>\n";
	    print "</table>\n";

	    print '<hr class="adminformseparator">'."\n";

	    my $topic = $news->getTopic();
	    print '<table border=0 cellpadding=0 cellspacing=0 class="netometb">'."\n";
	    print '<tr class="netometr">'."\n";
	    print '<td class="netometopleft"></td>'."\n";
	    print '<td class="netometop"></td>'."\n";
	    print '<td class="netometopright"></td>'."\n";
	    print "</tr>\n";
	    print '<tr class="netometr">'."\n";
	    print '<td class="netomeleft"></td>'."\n";
	    print '<td class="netometd">'."\n";
	    print "<div class=\"newstopicsmenu\">\n";
	    if ($topic)
	    {
		print $topic->getCode("menu");
	    }
	    else
	    {
		print  "<div class=\"newstopicmenu\">\n";
		print __("Topic");
		print "</div>\n";
	    }
	    print "</div>\n";
	    print "</td>\n";
	    print '<td class="netomeright"></td>'."\n";
	    print "</tr>\n";
	    print '<tr class="netometr">'."\n";
	    print '<td class="netomebottomleft"></td>'."\n";
	    print '<td class="netomebottom"></td>'."\n";
	    print '<td class="netomebottomright"></td>'."\n";
	    print "</tr>\n";
	    print "</table>\n";
	}

	print $cgi->footerCode();
	exit;
    }
}

my @themes = MN::Theme->getObjects("", "id");
foreach $theme (@themes)
{
    $theme->setCurrent();
}
my @themes2;
my $nbt = scalar(@themes);
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
if ($cgi->{check})
{
    print "<caption class=\"admintbtitle\">\n";
    print __("Check MyNews updates");
    print "</caption>\n";
    MN::Theme->getMyNewsUpdates();
    @themes2 = MN::Theme->getNewThemes();
    $nbt += scalar(@themes2);
}
print '<tr class="admintbr">'."\n";
print '<td class="admintbrtopleft">'."</td>\n";
print '<td class="admintbrtop">'."</td>\n";
print '<td class="admintbrtopright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrleft">'."</td>\n";
print '<td class="admintbr">'."\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
print '<tr class="adminheadertr">'."\n";
print '<td class="adminnumbertd2" title="';
if ($nbt > 1)
{
    printf(__("%d themes"), $nbt);
}
else
{
    printf(__("%d theme"), $nbt);
}
print '">'."#"."</td>\n";
print '<td class="adminheadertd">'.__("Id")."</td>\n";
if ($cgi->{check})
{
    print '<td class="adminheadertd">'.__("Status")."</td>\n";
}
else
{
    print '<td class="adminheadertd">'.__("Icon")."</td>\n";
}
print "</tr>\n";
my $row = "odd";
my $desc;
my $n = 0;

foreach $theme (@themes)
{
    print '<tr class="admin'.$row.'tr">'."\n";

    # number
    print '<td class="adminnumbertd">';
    $n++;
    print $n."\n";
    print "</td>\n";

    # id
    print '<td class="admin'.$row.'td">';
    print "<a href=\"themes.cgi?id=$theme->{id}\">$theme->{id}</a>\n";
    print "</td>\n";

    # icon / status
    $desc = $theme->{name}." : ".$theme->{comment};
    print '<td class="admin'.$row.'td">';
    if ($cgi->{check})
    {
	print $theme->getUpdateCode();
    }
    else
    {
	print '<img src="/css/themes/'.$theme->{id}.'/Logo.png" alt="'.$desc.'" title="'.$desc.'">'."\n";
    }
    print "</td>\n";

    print "</tr>\n";
    $row = $row eq "odd" ? "even" : "odd";
}
if ($cgi->{check})
{
    my $msg = __("Download");
    foreach $theme (@themes2)
    {
	print '<tr class="admin'.$row.'tr">'."\n";
	
	# number
	print '<td class="adminnumbertd">';
	$n++;
	print $n."\n";
	print "</td>\n";
	
	# id
	print '<td class="admin'.$row.'td">';
	print "<a href=\"$mne->{conf}->{mnurl}/themes/theme.php?id=$theme\">$theme</a>\n";
	print "</td>\n";
	
	#  status
	print '<td class="admin'.$row.'td">';
	print "<a href=\"themes.cgi?update=$theme\">\n";
	print "<div class=\"statusnew\" title=\"$msg\">\n";
	print "<img class=\"imgstatusnew\" src=\"$mne->{conf}->{weburl}/img/new.png\" alt=\"$msg\" title=\"$msg\" border=0>\n";
	print "</div>\n";
	print "</a>\n";
	print "</td>\n";
	print "</tr>\n";
	$row = $row eq "odd" ? "even" : "odd";
    }
}
print "</table>\n";
print "</td>\n";
print '<td class="admintbrright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrbottomleft">'."</td>\n";
print '<td class="admintbrbottom">'."</td>\n";
print '<td class="admintbrbottomright">'."</td>\n";
print "</tr>\n";
print "</table>\n";

print "<p>\n";
print "<form method=\"post\">\n";
if ($cgi->{check})
{
    print '<input class="adminformbutton" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
}
else
{
    print '<input class="adminformbutton" type="submit" name="new" value="'.__("New theme").'">'."\n";
    print '<input class="adminformbutton" type="submit" name="check" value="'.__("Check MyNews updates").'">'."\n";
}
print "</form>\n";

print $cgi->footerCode();
