#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

if (!$cgi->{cancel} && $cgi->{custom})
{
    my $topic = MN::Topic->getTopic($cgi->{custom});

    if ($cgi->{change})
    {
	rename("$mne->{conf}->{webdir}/img/topics/_$ENV{REMOTE_USER}_.png", "$mne->{conf}->{webdir}/img/topics/$topic->{id}.png");
	chmod(0664, "$mne->{conf}->{webdir}/img/topics/$topic->{id}.png");
    }
    else
    {
	print $cgi->headerCode(__("Admin"), "/admin", __("Topics"), "/admin/topics.cgi", $cgi->{custom}, "/admin/topics.cgi?id=$cgi->{custom}");
	
	print $cgi->menuCode();
	
	if ($cgi->{iconfile})
	{
	    $cgi->writeFileUpload("iconfile", "$mne->{conf}->{webdir}/img/topics/_$ENV{REMOTE_USER}_.png");
	}
	print "<form method=\"post\" enctype=\"multipart/form-data\">\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print "<caption class=\"adminformtitle\">\n";
	print $cgi->{custom}."\n";
	print "</caption>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=4 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Old icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $topic->getCode("menu");
	print "</td>\n";
	print '<td class="adminformlabel">'."\n";
	print __("New icon")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	if ($cgi->{try} && -e "$mne->{conf}->{webdir}/img/topics/_$ENV{REMOTE_USER}_.png")
	{
	    print "<div class=\"newstopicmenu\">\n";
	    print "<img src=\"$mne->{conf}->{weburl}/img/topics/_$ENV{REMOTE_USER}_.png\">\n";
	    print "</div>\n";
	}
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Icon file")."\n";
	print "</td>\n";
	print '<td colspan=2 class="adminformtd">'."\n";
	print '<input class="adminforminput" type="file" name="iconfile">'."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminformbutton" type="submit" name="try" value="'.__("Try").'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td colspan=4 class="adminformtd">'."\n";
	print '<hr class="adminformseparator">'."\n";
	if ($cgi->{try})
	{
	    print '<input class="adminformbutton" type="submit" name="change" value="'.__("Submit").'">'."\n";
	}
	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	
	print '<input type="hidden" name="custom" value="'.$cgi->{custom}.'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=4 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";

	print "</table>\n";
	
	print "<form>\n";
	print $cgi->footerCode();
	exit;
    }
}
elsif ($cgi->{reload})
{
    my $topic = MN::Topic->getTopic($cgi->{reload});
    my $res = $topic->getTopicIcon();
    if ($res)
    {
	$cgi->setAlert("Error when reloading icon from website (%s)", $res);
    }
    else
    {
	$cgi->setAlert("Icon sucessfully reloaded from website");
    }
}

print $cgi->headerCode(__("Admin"), "/admin", __("Topics"), "/admin/topics.cgi");

print $cgi->menuCode();

my @topics = MN::Topic->getObjects("", "id");

my $topic;
my $ctmpl = 0;
my $tmpl;
my $n = 0;
foreach $topic (@topics)
{
    $tmpl = $topic->getTemplate();
    if ($tmpl != $ctmpl)
    {
	if ($ctmpl)
	{
	    print "</tr>\n";
	    print "</table>\n";
	    print "</div>\n";
	}
	$n = 0;
	print "<div class=\"tls\">\n";

	print '<table border=0 cellpadding=0 cellspacing=0 width="100%" class="netetlstb">'."\n";
	print '<tr class="netetlstr">'."\n";
	print '<td class="netetlstopleft"></td>'."\n";
	print '<td class="netetlstop"></td>'."\n";
	print '<td class="netetlstopright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="netetlstr">'."\n";
	print '<td class="netetlsleft"></td>'."\n";
	print '<td class="netetlstd">'."\n";
	print $tmpl->getCode("tls");
	print "</td>\n";
	print '<td class="netetlsright"></td>'."\n";
	print "</tr>\n";
	print '<tr class="netetlstr">'."\n";
	print '<td class="netetlsbottomleft"></td>'."\n";
	print '<td class="netetlsbottom"></td>'."\n";
	print '<td class="netetlsbottomright"></td>'."\n";
	print "</tr>\n";
	print "</table>\n";

	print '<table border=0 cellpadding=0 cellspacing=0 width="100%" class="netotlstb">'."\n";
	print '<tr class="netotlstr">'."\n";

	$ctmpl = $tmpl;
    }
    if ($n > 4)
    {
	$n = 0;
	print "</tr>\n";
	print '<tr class="netotlstr">'."\n";
    }
    print '<td class="netotlstd">'."\n";
    print $topic->getCode("tls",1);
    print "</td>\n";
    $n++;
}
if ($ctmpl)
{
    print "</tr>\n";
    print "</table>\n";
    print "</div>\n";
}
print $cgi->footerCode();
