#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my @extra = ();
if ($cgi->{login})
{
    push @extra, $cgi->{login}, "/admin/users.cgi?id=$cgi->{login}";
}
elsif ($cgi->{new})
{
    push @extra, __("New user"), "/admin/users.cgi?new=1";
}
print $cgi->headerCode(__("Admin"), "/admin", __("Users"), "/admin/users.cgi", @extra);

print $cgi->menuCode();

my $user;

if ($cgi->{delete}  && $cgi->{login})
{
    $user = MN::User->getObject($cgi->{login});
    if ($user && $user->{login} ne $ENV{REMOTE_USER})
    {
	$user->delete();
    }
}
elsif (!$cgi->{cancel} && ($cgi->{login} || $cgi->{new}))
{
    if ($cgi->{login})
    {
	$user = MN::User->getObject($cgi->{login});
    }
    if ($cgi->{create})
    {
	if ($user)
	{
	    $cgi->error("User %s already exists", $cgi->{login});
	}
	$user = new MN::User();
	$user->{login} = $cgi->{login};
	if ($cgi->{password})
	{
	    $user->setPassword($cgi->{password});
	}
	else
	{
	    $user->setPassword($cgi->{login});
	}
	$user->{firstname} = $cgi->{firstname};
	$user->{lastname} = $cgi->{lastname};
	$user->{mail} = $cgi->{mail};
	$user->{lang} = $cgi->{lang};
	$user->{theme} = $cgi->{theme};
	$user->setDisplay($cgi->{display});
	$user->{newsperpage} = $cgi->{newsperpage};
	$user->add();
	if ($cgi->{admin})
	{
	    $user->setAdmin($cgi->{admin});
	}
    }
    elsif ($cgi->{modify})
    {
	if (!$user)
	{
	    $cgi->error("User %s doesn't exist", $cgi->{login});
	}
	if ($cgi->{password})
	{
	    $user->setPassword($cgi->{password});
	}
	$user->{firstname} = $cgi->{firstname};
	$user->{lastname} = $cgi->{lastname};
	$user->{mail} = $cgi->{mail};
	$user->{lang} = $cgi->{lang};
	$user->{theme} = $cgi->{theme};
	$user->setDisplay($cgi->{display});
	$user->{newsperpage} = $cgi->{newsperpage};
	$user->modify();
	if ($cgi->{admin} != $cgi->{oldadmin})
	{
	    $user->setAdmin($cgi->{admin});
	}
    }
    else
    {
	if (!$user)
	{
	    $user = new MN::User();
	    $user->{lang} = MN::CGI::getUser()->{lang};
	    $user->setAllDisplay();
	    $user->{newsperpage} = $mne->getNPP();
	}
	print "<form method=\"post\">\n";
	print "<table border=0 cellspacing=0 cellpadding=0 class=\"adminform\">\n";
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformtopleft"></td>'."\n";
	print '<td colspan=2 class="adminformtop"></td>'."\n";
	print '<td class="adminformtopright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Login")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input type="text" name="login" value="'.$cgi->{login}.'" size="50"';
	if ($cgi->{login})
	{
	    print 'class="roadminforminput" readonly onfocus="blur();"';
	}
	else
	{
	    print 'class="adminforminput"';
	}
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Password")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="password" name="password" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("First name")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="firstname" value="'.$cgi->unquote($user->{firstname}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Last name")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="lastname" value="'.$cgi->unquote($user->{lastname}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("E-mail address")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print '<input class="adminforminput" type="text" name="mail" value="'.$cgi->unquote($user->{mail}).'" size="50">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Language")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $cgi->langSelectorCode($user->{lang});
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Theme")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print MN::Theme->getSelectorCode($user->{theme});
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Display")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $user->displaySelectorCode();
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("News per page")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $user->nppSelectorCode();
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformlabel">'."\n";
	print __("Admin")."\n";
	print "</td>\n";
	print '<td class="adminformtd">'."\n";
	print $user->adminSelectorCode();
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformtd" colspan=2>'."\n";
	print '<hr class="adminformseparator">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";
	
	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformleft"></td>'."\n";
	print '<td class="adminformtd" colspan=2>'."\n";
	if ($cgi->{login})
	{
	    print '<input class="adminformbutton" type="submit" name="modify" value="'.__("Modify").'">'."\n";
	    if ($cgi->{login} ne $ENV{REMOTE_USER})
	    {
		print '<input class="adminformbutton" type="submit" name="delete" value="'.__("Delete").'" '.$cgi->confirmCode("Do you really want to delete user %s?", $cgi->{login}).">\n";
	    }
	}
	else
	{
	    print '<input class="adminformbutton" type="submit" name="create" value="'.__("Create").'">'."\n";
	}
	print '<input class="adminformbutton2" type="submit" name="cancel" value="'.__("Cancel").'">'."\n";
	print "</td>\n";
	print '<td class="adminformright"></td>'."\n";
	print "</tr>\n";

	print '<tr class="adminformtr">'."\n";
	print '<td class="adminformbottomleft"></td>'."\n";
	print '<td colspan=2 class="adminformbottom"></td>'."\n";
	print '<td class="adminformbottomright"></td>'."\n";
	print "</tr>\n";
	
	print "</table>\n";
	print "</form>\n";
	print $cgi->footerCode();
	exit;
    }
}

my @users = MN::User->getObjects("", "login");
my $nbu = scalar(@users);
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintbr\">\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrtopleft">'."</td>\n";
print '<td class="admintbrtop">'."</td>\n";
print '<td class="admintbrtopright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrleft">'."</td>\n";
print '<td class="admintbr">'."\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"admintb\">\n";
print '<tr class="adminheadertr">'."\n";
print '<td class="adminnumbertd2" title="';
if ($nbu > 1)
{
    printf(__("%d users"), $nbu);
}
else
{
    printf(__("%d user"), $nbu);
}
print '">'."#"."</td>\n";
print '<td class="adminheadertd">'.__("Login")."</td>\n";
print '<td class="adminheadertd">'.__("Admin")."</td>\n";
print '<td class="adminheadertd">'.__("Name")."</td>\n";
print '<td class="adminheadertd">'.__("E-mail address")."</td>\n";
print '<td class="adminheadertd">'.__("Subscriptions")."</td>\n";
print "</tr>\n";
my $row = "odd";
my $tmpl;
my $n = 0;

foreach $user (@users)
{
    print '<tr class="admin'.$row.'tr">'."\n";

    # number
    print '<td class="adminnumbertd">';
    $n++;
    print $n."\n";
    print "</td>\n";

    # login
    print '<td class="admin'.$row.'td">';
    print "<a href=\"users.cgi?login=$user->{login}\">$user->{login}</a>\n";
    print "</td>\n";

    # admin
    print '<td class="admin'.$row.'td">';
    print $user->isAdmin()."\n";
    print "</td>\n";

    # name
    print '<td class="admin'.$row.'td">';
    print $user->getLongName();
    print "\n";
    print "</td>\n";

    # mail
    print '<td class="admin'.$row.'td">';
    if ($user->{mail})
    {
	print "<a href=\"maito:$user->{mail}\">$user->{mail}</a>\n";
    }
    else
    {
	print "&nbsp;\n";
    }
    print "</td>\n";

    # subscriptions
    print '<td class="admin'.$row.'td">';
    my $tmpls = $user->getSubTemplates(1);
    foreach $tmpl (@{$tmpls})
    {
	print "<div class=\"admintemplate\">\n";
	print "<a href=\"templates.cgi?id=$tmpl->{id}\">$tmpl->{name}</a>\n";
	print "</div>\n";
    }
    if (!scalar(@{$tmpls}))
    {
	print "&nbsp;\n";
    }
    print "</td>\n";

    print "</tr>\n";
    $row = $row eq "odd" ? "even" : "odd";
}
print "</table>\n";
print "</td>\n";
print '<td class="admintbrright">'."</td>\n";
print "</tr>\n";
print '<tr class="admintbr">'."\n";
print '<td class="admintbrbottomleft">'."</td>\n";
print '<td class="admintbrbottom">'."</td>\n";
print '<td class="admintbrbottomright">'."</td>\n";
print "</tr>\n";
print "</table>\n";

print "<p>\n";
print "<form metho=\"post\">\n";
print '<input class="adminformbutton" type="submit" name="new" value="'.__("New user").'">'."\n";
print "</form>\n";

print $cgi->footerCode();
