#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

print $cgi->headerCode();

print $cgi->menuCode();

my $condition;
my $user = $cgi->getUser();
my $limit = $mne->getNPP();

if ($user)
{
    $condition = $user->getSubCondition();
    if (!$condition)
    {
	print "<div class=\"welcome\">\n";
	print __("Welcome to MyNews");
	print "<p>\n";
	if (MN::Template->getObjectsCount())
	{
	    print __("You haven't any subscription yet");
	    print "<p>\n";
	    printf(__("Click on %s button to display available news sites"), '<a href="other.cgi">'.__("Other sites")."</a>");
	    print "<p>\n";
	    my $gs = __("Getting started");
	    my $gs2 = lc($gs);
	    $gs2 =~ s/\W//g;
	    printf(__("or take a look at the %s section of MyNews documentation"), '<a href="lang/'.$user->{lang}.'/index.cgi?file=index.html#'.$gs2.'">'.$gs."</a>");
	}
	else
	{
	    printf(__("Click %s to download your first template"), '<a href="admin/templates.cgi?check=1">'.__("here").'</a>');
	    print "<p>\n";
	    my $gs = __("First connection of admin user");
	    my $gs2 = lc($gs);
	    $gs2 =~ s/\W//g;
	    printf(__("or take a look at the %s section of MyNews documentation"), '<a href="lang/'.$user->{lang}.'/index.cgi?file=index.html#'.$gs2.'">'.$gs."</a>");
	}
	print "</div>\n";
	print $cgi->footerCode();
	exit();
    }
    $limit = $user->{newsperpage};
}
else
{
    $condition = MN::Template->getActiveCondition();
}
my $offset = 0;
my $page = $cgi->getPage();
if ($page)
{
    $offset = ($page - 1) * $limit;
}
my @nnews = MN::News->getObjects($condition, "date desc, crtime desc", $limit, $offset);

my $nbn = scalar(@nnews);
my $lastpage = 0;
if ($nbn == 0)
{
    $page --;
    $offset -= $limit;
    if ($offset < 0) { $offset = 0; }
    @nnews = MN::News->getObjects($condition, "date desc, crtime desc", $limit, $offset);
    $nbn = scalar(@nnews);
    $lastpage = 1;
}
if ($nbn < $limit)
{
    $lastpage = 1;
}

my $news;
my $num = $offset + 1;

print "<form method=\"POST\">\n";
print '<input type="hidden" name="page" value="'.$page.'">'."\n";

my $pagebar = $cgi->pagebarCode($page, $lastpage);
if ($page)
{
    print $pagebar;
}

foreach $news (@nnews)
{
    print $news->getCode($num++);
}

print $pagebar;

print "</form>\n";

print $cgi->footerCode();
