#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my $user = $cgi->getUser();
my @navitems = ();

my $news = MN::News->getObject($cgi->{id});
if (!$news)
{
    $cgi->error("News %s doesn't exist", $cgi->{id});
}

my $tmpl = $news->getTemplate();

if (!$tmpl)
{
    $cgi->error("Template %s doesn't exist", $news->{template})
}

if ($user && !MN::Subscr->getObject($tmpl->{id}, $user->{login}))
{
    push @navitems, __("Other sites"), "/other.cgi";
}
push @navitems, $tmpl->{name}, "/template.cgi?id=$tmpl->{id}";

if ($news->{topic})
{
    my $topic = $news->getTopic();

    if (!$topic)
    {
	$cgi->error("Topic %s doesn't exist", $news->{topic});
    }
    push @navitems, $topic->{name}, "/topic.cgi?id=$topic->{id}";
}
my $max = 60;
my $name = $news->{name};
if (length($name) > $max)
{
    $name = substr($name, 0, $max);
    $name =~ s/\s\S*$/\.\.\./;
}
push @navitems, $name, "/news.cgi?id=$news->{id}";

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

print $news->getCode();

print $cgi->footerCode();
