#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

print $cgi->headerCode(__("Other sites"), "/other.cgi");

print $cgi->menuCode();

my $condition;
my $user = $cgi->getUser();
my $limit = $mne->getNPP();

if ($user)
{
    $condition = $user->getUnsubCondition();
    if (!$condition)
    {
	print "<div class=\"welcome\">\n";
	print __("No available news sites");
	print "</div>\n";
	print $cgi->footerCode();
	exit();
    }
    $limit = $user->{newsperpage};
}
else
{
    $condition = MN::Template->getActiveCondition();
}

my $offset = 0;
my $page = $cgi->getPage();
if ($page)
{
    $offset = ($page - 1) * $limit;
}
my @nnews = MN::News->getObjects($condition, "date desc, crtime desc", $limit, $offset);

my $nbn = scalar(@nnews);
my $lastpage = 0;
if ($nbn == 0)
{
    $page --;
    $offset -= $limit;
    if ($offset < 0) { $offset = 0; }
    @nnews = MN::News->getObjects($condition, "date desc, crtime desc", $limit, $offset);
    $nbn = scalar(@nnews);
    $lastpage = 1;
}
if ($nbn < $limit)
{
    $lastpage = 1;
}

my $news;
my $num = $offset + 1;

print "<form method=\"POST\">\n";
print '<input type="hidden" name="page" value="'.$page.'">'."\n";

my $pagebar = $cgi->pagebarCode($page, $lastpage);
if ($page)
{
    print $pagebar;
}
else
{
    print "<div class=\"welcome\">\n";
    printf __("Click on news sites icon to subscribe");
    print "</div>\n";
}

my @nnews = MN::News->getObjects($condition, "date desc, crtime desc", $limit, $offset);

my $news;

foreach $news (@nnews)
{
    print $news->getCode($num++);
}

print $pagebar;

print $cgi->footerCode();
