#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my $user = MN::CGI::getUser();

if (defined $cgi->{lang})
{
    $cgi->setLang($cgi->{lang});
    $user->{lang} = $cgi->{lang};
    $user->setDisplay($cgi->{display});
}
if (defined $cgi->{theme})
{
    $user->{theme} = $cgi->{theme};
}
if (defined $cgi->{firstname})
{
    $user->{firstname} = $cgi->{firstname};
}
if (defined $cgi->{lastname})
{
    $user->{lastname} = $cgi->{lastname};
}
if (defined $cgi->{mail})
{
    $user->{mail} = $cgi->{mail};
}
if (defined $cgi->{newsperpage})
{
    $user->{newsperpage} = $cgi->{newsperpage};
}

if ($cgi->{change})
{
    my $msg;
    if ($cgi->{newpassword1})
    {
	# check for old password
	if (!$cgi->{oldpassword} || !$user->checkPassword($cgi->{oldpassword}))
	{
	    $msg = "Invalid old password";
	}
	elsif ($cgi->{newpassword1} ne $cgi->{newpassword2})
	{
	    $msg = "New password mismatch";
	}
	else
	{
	    $user->setPassword($cgi->{newpassword1});
	}
    }
    if (!$msg)
    {
	$user->modify();
	$msg = "Your preferences has been changed";
    }
    $cgi->setAlert($msg);
}

print $cgi->headerCode(__("Preferences"), "/prefs.cgi");

print $cgi->menuCode();


print "<form method=\"post\">\n";

print "<table border=0 cellspacing=10 cellpadding=0>\n";
print "<tr valign=\"top\">\n";

# identity
print "<td>\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"form\">\n";

print "<caption class=\"formtitle\">\n";
print __("Identity")."\n";
print "</caption>\n";

print '<tr class="formtr">'."\n";
print '<td class="formtopleft"></td>'."\n";
print '<td colspan=2 class="formtop"></td>'."\n";
print '<td class="formtopright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("First name")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<input class="forminput" type="text" name="firstname" value="'.$cgi->unquote($user->{firstname}).'" size="30">'."\n";
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Last name")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<input class="forminput" type="text" name="lastname" value="'.$cgi->unquote($user->{lastname}).'" size="30">'."\n";
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("E-mail address")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<input class="forminput" type="text" name="mail" value="'.$cgi->unquote($user->{mail}).'" size="30">'."\n";
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formbottomleft"></td>'."\n";
print '<td colspan=2 class="formbottom"></td>'."\n";
print '<td class="formbottomright"></td>'."\n";
print "</tr>\n";

print "</table>\n";
print "</td>\n";

# password
print "<td>\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"form\">\n";

print "<caption class=\"formtitle\">\n";
print __("Password")."\n";
print "</caption>\n";

print '<tr class="formtr">'."\n";
print '<td class="formtopleft"></td>'."\n";
print '<td colspan=2 class="formtop"></td>'."\n";
print '<td class="formtopright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Old password")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<input class="forminput" type="password" name="oldpassword" value="'.$cgi->unquote($cgi->{oldpassword}).'" size="20">'."\n";
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("New password")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<input class="forminput" type="password" name="newpassword1" value="'.$cgi->unquote($cgi->{newpassword1}).'" size="20">'."\n";
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("One more time")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<input class="forminput" type="password" name="newpassword2" value="'.$cgi->unquote($cgi->{newpassword2}).'" size="20">'."\n";
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formbottomleft"></td>'."\n";
print '<td colspan=2 class="formbottom"></td>'."\n";
print '<td class="formbottomright"></td>'."\n";
print "</tr>\n";

print "</table>\n";
print "</td>\n";

print "</tr>\n";
print "</table>\n";

print "<table border=0 cellspacing=10 cellpadding=0>\n";
print "<tr valign=\"top\">\n";

# visual
print "<td>\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"form\">\n";

print "<caption class=\"formtitle\">\n";
print __("Visual")."\n";
print "</caption>\n";

print '<tr class="formtr">'."\n";
print '<td class="formtopleft"></td>'."\n";
print '<td colspan=2 class="formtop"></td>'."\n";
print '<td class="formtopright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Language")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print $cgi->langSelectorCode($user->{lang}, 1);
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Theme")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print MN::Theme->getSelectorCode($user->{theme}, 1);
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Display")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print $user->displaySelectorCode(1);
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("News per page")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print $user->nppSelectorCode();
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formbottomleft"></td>'."\n";
print '<td colspan=2 class="formbottom"></td>'."\n";
print '<td class="formbottomright"></td>'."\n";
print "</tr>\n";

print "</table>\n";
print "</td>\n";

# preview
print "<td width=\"100%\">\n";
print "<table border=0 cellspacing=0 cellpadding=0 width=\"100%\">\n";

print "<caption class=\"formtitle\">\n";
print __("Preview")."\n";
print "</caption>\n";

print '<tr>'."\n";
print '<td class="maintd">'."\n";

my $condition;
my $user = $cgi->getUser();
if ($user)
{
    $condition = $user->getSubCondition() || "";
}
my @nnews = MN::News->getObjects($condition, "date desc, crtime desc", 1);
if (!scalar(@nnews))
{
    @nnews = MN::News->getObjects("", "date desc, crtime desc", 1);
}
my $news = shift @nnews;
if ($news)
{
    print $news->getCode(1);
}

print "</td>\n";
print "</tr>\n";

print "</table>\n";
print "</td>\n";

print "</tr>\n";
print "</table>\n";

print '<hr class="formseparator">'."\n";

print '<input class="formbutton" type="submit" name="change" value="'.__("Submit").'">'."\n";
print '<input class="formbutton2" type="submit" onclick="top.location.href=\''.$ENV{SCRIPT_NAME}.'\';return false;" value="'.__("Cancel").'">'."\n";

print "</form>\n";

_c_(__("Console"));

print $cgi->footerCode();
