#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();

my @navitems = ();
my $sparam = "";
my $topic;
my $tmpl;
my $user = $cgi->getUser();

if ($cgi->{topic})
{
    $topic = MN::Topic->getTopic($cgi->{topic});
    if (!$topic)
    {
	$cgi->error("Topic %s doesn't exist", $cgi->{topic});
    }
    $tmpl = $topic->getTemplate();
    if (!$tmpl)
    {
	$cgi->error("Template %s doesn't exist", $topic->getTemplateId());
    }
    if ($user && !MN::Subscr->getObject($tmpl->{id}, $user->{login}))
    {
	push @navitems, __("Other sites"), "/other.cgi";
    }
    push @navitems, $tmpl->{name}, "/template.cgi?id=$tmpl->{id}";
    push @navitems, $topic->{name}, "/topic.cgi?id=$topic->{id}";
    $sparam = "?topic=$cgi->{topic}";
}
elsif ($cgi->{template})
{
    $tmpl = MN::Template->getTemplate($cgi->{template});
    if (!$tmpl)
    {
	$cgi->error("Template %s doesn't exist", $cgi->{template});
    }
    if ($user && !MN::Subscr->getObject($tmpl->{id}, $user->{login}))
    {
	push @navitems, __("Other sites"), "/other.cgi";
    }
    push @navitems, $tmpl->{name}, "/template.cgi?id=$tmpl->{id}";
    $sparam = "?template=$cgi->{template}";
}
elsif ($cgi->{other})
{
    push @navitems, __("Other sites"), "/other.cgi";
    $sparam = "?other=1";
}
push @navitems, __("Search"), "/search.cgi$sparam";

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

print "<form method=\"post\">\n";
print "<table border=0 cellspacing=0 cellpadding=0 class=\"form\">\n";

print "<caption class=\"formtitle\">\n";
print __("Search")."\n";
print "</caption>\n";

print '<tr class="formtr">'."\n";
print '<td class="formtopleft"></td>'."\n";
print '<td colspan=8 class="formtop"></td>'."\n";
print '<td class="formtopright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formleft"></td>'."\n";
print '<td class="formlabel">'."\n";
print __("Keywords")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<input class="forminput" type="text" name="keywords" value="'.$cgi->unquote($cgi->{keywords}).'" size="40">'."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<select class="formselect" name="or">'."\n";
print '<option value="0">'.__("and")."\n";
print '<option value="1"';
if ($cgi->{or})
{
    print " selected";
}
print '>'.__("or")."\n";
print "</select>\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<input class="formbutton" type="submit" value="'.__("Search").'">'."\n";
print "</td>\n";
print '<td class="formlabel">'."\n";
print __("in")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<select class="formselect" name="in">'."\n";
print '<option value="0">'.__("Title only")."\n";
print '<option value="1"';
if ($cgi->{in})
{
    print " selected";
}
print '>'.__("Title and body")."\n";
print "</select>\n";

print '<td class="formlabel">'."\n";
print __("of")."\n";
print "</td>\n";
print '<td class="formtd">'."\n";
print '<select class="formselect" name="of">'."\n";
if ($topic)
{
    print '<option value="4"';
    if ($cgi->{of} && $cgi->{of} == 4) { print " selected"; }
    print '>'.$topic->{name}."\n";
}
if ($tmpl)
{
    print '<option value="5"';
    if ($cgi->{of} && $cgi->{of} == 5) { print " selected"; }
    print '>'.$tmpl->{name}."\n";
}
if ($user)
{
    print '<option value="1"';
    if ($cgi->{of} && $cgi->{of} == 1) { print " selected"; }
    print '>'.__("My subscriptions")."\n";
    print '<option value="2"';
    if ($cgi->{of})
    {
	if ($cgi->{of} == 2) { print " selected"; }
    }
    elsif ($cgi->{other}) { print " selected"; }
    print '>'.__("Other sites")."\n";
}
print '<option value="3"';
if ($cgi->{of} && $cgi->{of} == 3) { print " selected"; }
print '>'.__("All sites")."\n";
print "</select>\n";
print "</td>\n";
print '<td class="formright"></td>'."\n";
print "</tr>\n";

print '<tr class="formtr">'."\n";
print '<td class="formbottomleft"></td>'."\n";
print '<td colspan=8 class="formbottom"></td>'."\n";
print '<td class="formbottomright"></td>'."\n";
print "</tr>\n";

print "</table>\n";
if ($cgi->{topic})
{
    print '<input type="hidden" name="topic" value="'.$cgi->{topic}.'">'."\n";;
}
elsif ($cgi->{template})
{
    print '<input type="hidden" name="template" value="'.$cgi->{template}.'">'."\n";;
}
elsif ($cgi->{other})
{
    print '<input type="hidden" name="other" value="'.$cgi->{other}.'">'."\n";;
}

if ($cgi->{keywords})
{
    my $condition = "";
    my $user = $cgi->getUser();
    my $limit = $mne->getNPP();
    my $sep = " and (";
    if ($cgi->{of} == 3)
    {
	$condition = MN::Template->getActiveCondition();
    }
    if ($cgi->{of} == 4)
    {
	$condition = "topic = '$topic->{id}'";
    }
    elsif ($cgi->{of} == 5)
    {
	$condition = "template = '$tmpl->{id}'";
    }
    elsif ($user)
    {
	if ($cgi->{of} == 1)
	{
	    $condition = $user->getSubCondition();
	}
	elsif ($cgi->{of} == 2)
	{
	    $condition = $user->getUnsubCondition();
	}
    }
    else
    {
	$condition = MN::Template->getCurrentCondition();
    }
    if ($user)
    {
	$limit = $user->{newsperpage};
    }
    my $offset = 0;
    my $page = $cgi->getPage(1);
    if ($page)
    {
	$offset = ($page - 1) * $limit;
    }

    my @keywords = $cgi->getKeywords("default", $cgi->{keywords});
    my $keyword;
    my $operator;
    if ($cgi->{or})
    {
	$operator = "or";
    }
    else
    {
	$operator = "and";
    }
    my $fstr;
    if ($cgi->{in})
    {
	$fstr = $mne->sqlConcat("default", "name","body");
    }
    else
    {
	$fstr = "name";
    }
    foreach $keyword (@keywords)
    {
	$condition .= $sep."lower($fstr) like '%$keyword%'";
	$sep = " $operator ";
    }
    $condition .= ")";

    _c_("search condition = [$condition]\n");

    my @nnews = MN::News->getObjects($condition, "date desc, crtime desc", $limit, $offset);

    my $nbn = scalar(@nnews);
    my $lastpage = 0;
    if ($nbn == 0)
    {
	$page --;
	$offset -= $limit;
	if ($offset < 0) { $offset = 0; }
	@nnews = MN::News->getObjects($condition, "date desc, crtime desc", $limit, $offset);
	$nbn = scalar(@nnews);
	$lastpage = 1;
    }
    if ($nbn < $limit)
    {
	$lastpage = 1;
    }
    
    my $news;
    my $num = $offset + 1;

    my $pagebar = $cgi->pagebarCode($page, $lastpage);
	
    print "<p>\n";

    print $pagebar;
    
    foreach $news (@nnews)
    {
	print $news->getCode($num++, "", "", 0, 1+$cgi->{in}, @keywords);
    }
    
    print $pagebar;

    if ($nbn == 0) # no match
    {
	print '<table border=0 cellspacing=0 cellpadding=0 class="nomatchtb">'."\n";
	print '<tr class="nomatchtr">'."\n";
	print '<td class="nomatchtopleft">'."</td>\n";
	print '<td class="nomatchtop">'."</td>\n";
	print '<td class="nomatchtopright">'."</td>\n";
	print "</tr>\n";
	print '<tr class="nomatchtr">'."\n";
	print '<td class="nomatchleft">'."</td>\n";
	print '<td class="nomatchtd">'."\n";
	print '<div class="nomatch">'.__("No match")."</div>\n";
	print "</td>\n";
	print '<td class="nomatchright">'."</td>\n";
	print "</tr>\n";
	print '<tr class="nomatchtr">'."\n";
	print '<td class="nomatchbottomleft">'."</td>\n";
	print '<td class="nomatchbottom">'."</td>\n";
	print '<td class="nomatchbottomright">'."</td>\n";
	print "</tr>\n";
	print "</table>\n";
    }

    print '<input type="hidden" name="page" value="'.$page.'">'."\n";
}

print "</form>\n";

print $cgi->footerCode();
