#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();
my $tmpl = new MN::Template();
$tmpl->{id} = "mynews";
$tmpl->{name} = "MyNews";
$tmpl->{url} = "$mne->{conf}->{weburl}/";
$tmpl->{comment} = "Test MyNews website";
$tmpl->{lang} = "en";
$tmpl->{active} = "1";

my $lines = $tmpl->getHTMLPage();

if (!$tmpl->{http_code}) # DNS pb
{
    die "Unable to access to $tmpl->{url}";
}
elsif ($tmpl->{http_code} == 200) # OK
{
    print "Access to $tmpl->{url}: ok\n";
}
else # bad return status
{
    $lines =~ s/<[^>]+>//mg;
    die "Bad return code $tmpl->{http_code} for $tmpl->{url}\n$lines";
}

open(FILE, ">$mne->{conf}->{webdir}/test.cgi") || die "Unable to create $mne->{conf}->{webdir}/test.cgi file";
print FILE "#!/usr/bin/perl\n";
print FILE "print \"Content-Type: text/plain\\n\\n\";\n";
print FILE "print \"OK\\n\";\n";
close(FILE);
chmod(0755, "$mne->{conf}->{webdir}/test.cgi");

$tmpl->{url} .= "test.cgi";
$lines = $tmpl->getHTMLPage();

if (!$tmpl->{http_code}) # DNS pb
{
    die "Unable to access to $tmpl->{url}";
}
elsif ($tmpl->{http_code} == 200) # OK
{
    chomp($lines);
    if ($lines eq "OK")
    {
	print "Access to $tmpl->{url}: ok\n";
	unlink("$mne->{conf}->{webdir}/test.cgi");
    }
    else
    {
	die "Bad answer for $tmpl->{url}\n$lines";
    }
}
else # bad return status
{
    $lines =~ s/<[^>]+>//mg;
    die "Bad return code $tmpl->{http_code} for $tmpl->{url}\n$lines";
}
