#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my $user = $cgi->getUser();
my @navitems = ();

my $tmpl = MN::Template->getTemplate($cgi->{id});

if (!$tmpl)
{
    $cgi->error("Template %s doesn't exist", $cgi->{id});
}

if ($cgi->{swsub} && $user)
{
    my $sb = MN::Subscr->getObject($cgi->{id}, $user->{login});
    if ($sb)
    {
	$sb->delete();
	$cgi->setAlert("You have been unsubscribed from %s", $cgi->{id});
    }
    else
    {
	$sb = new MN::Subscr();
	$sb->{template} = $cgi->{id};
	$sb->{user} = $user->{login};
	$sb->add();
	$cgi->setAlert("You have been subscribed to %s", $cgi->{id});
    }
}
if ($user && !MN::Subscr->getObject($cgi->{id}, $user->{login}))
{
    push @navitems, __("Other sites"), "/other.cgi";
}
push @navitems, $tmpl->{name}, "/template.cgi?id=$cgi->{id}";

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

if ($cgi->{idcard})
{
    print "<table border=0 cellspacing=0 cellpadding=0 class=\"form\">\n";
    
    print "<caption class=\"formtitle\">\n";
    print $tmpl->menuTitle()."\n";
    print "</caption>\n";
    
    print '<tr class="formtr">'."\n";
    print '<td class="formtopleft"></td>'."\n";
    print '<td colspan=2 class="formtop"></td>'."\n";
    print '<td class="formtopright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formtd">'."\n";
    print "&nbsp;\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $tmpl->getCode()."\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Name")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $tmpl->{name}."\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Comment")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $tmpl->{comment}."\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    if ($tmpl->{url} =~ /^http/)
    {
	print '<tr class="formtr">'."\n";
	print '<td class="formleft"></td>'."\n";
	print '<td class="formlabel">'."\n";
	print __("URL")."\n";
	print "</td>\n";
	print '<td class="formtd">'."\n";
	print '<a href="'.$tmpl->{url}.'">'.$tmpl->{url}."</a>\n";
	print "</td>\n";
	print '<td class="formright"></td>'."\n";
	print "</tr>\n";
    }

    my $nbt = MN::Topic->getObjectsCount("id like '$tmpl->{id}_%'");
    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("Topics")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $nbt."</a>\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    my $nbn = MN::News->getObjectsCount("template='$tmpl->{id}'");
    print '<tr class="formtr">'."\n";
    print '<td class="formleft"></td>'."\n";
    print '<td class="formlabel">'."\n";
    print __("News")."\n";
    print "</td>\n";
    print '<td class="formtd">'."\n";
    print $nbn."</a>\n";
    print "</td>\n";
    print '<td class="formright"></td>'."\n";
    print "</tr>\n";

    print '<tr class="formtr">'."\n";
    print '<td class="formbottomleft"></td>'."\n";
    print '<td colspan=2 class="formbottom"></td>'."\n";
    print '<td class="formbottomright"></td>'."\n";
    print "</tr>\n";
    
    print "</table>\n";
}
else
{
    my $limit = $mne->getNPP();
    if ($user)
    {
	$limit = $user->{newsperpage};
    }
    my $offset = 0;
    my $page = $cgi->getPage();
    if ($page)
    {
	$offset = ($page - 1) * $limit;
    }
    
    my @nnews = MN::News->getObjects("template = '$cgi->{id}'", "date desc, crtime desc", $limit, $offset);
    my $nbn = scalar(@nnews);
    my $lastpage = 0;
    if ($nbn == 0)
    {
	$page --;
	$offset -= $limit;
	if ($offset < 0) { $offset = 0; }
	@nnews = MN::News->getObjects("template = '$cgi->{id}'", "date desc, crtime desc", $limit, $offset);
	$nbn = scalar(@nnews);
	$lastpage = 1;
    }
    if ($nbn < $limit)
    {
	$lastpage = 1;
    }
    
    my $news;
    my $num = $offset + 1;
    
    print "<form method=\"POST\">\n";
    print '<input type="hidden" name="page" value="'.$page.'">'."\n";
    print '<input type="hidden" name="id" value="'.$cgi->{id}.'">'."\n";
    
    my $pagebar = $cgi->pagebarCode($page, $lastpage);
    if ($page)
    {
	print $pagebar;
    }
    
    foreach $news (@nnews)
    {
	print $news->getCode($num++,"hidden");
    }
    
    print $pagebar;
}

print $cgi->footerCode();
