#!/usr/bin/perl

use strict;
use MN 1.0;

my $mne = new MN::Engine();

my $cgi = new MN::CGI();
my $user = $cgi->getUser();
my @navitems = ();

my $topic = MN::Topic->getTopic($cgi->{id});
if (!$topic)
{
    $cgi->error("Topic %s doesn't exist", $cgi->{id});
}
my $tmpl = $topic->getTemplate();
if (!$tmpl)
{
    $cgi->error("Template %s doesn't exist", $topic->getTemplateId());
}
if ($user && !MN::Subscr->getObject($tmpl->{id}, $user->{login}))
{
    push @navitems, __("Other sites"), "/other.cgi";
}
push @navitems, $tmpl->{name}, "/template.cgi?id=$tmpl->{id}";
push @navitems, $topic->{name}, "/topic.cgi?id=$topic->{id}";

print $cgi->headerCode(@navitems);

print $cgi->menuCode();

my $limit = $mne->getNPP();
if ($user)
{
    $limit = $user->{newsperpage};
}
my $offset = 0;
my $page = $cgi->getPage();
if ($page)
{
    $offset = ($page - 1) * $limit;
}

my @nnews = MN::News->getObjects("topic = '$cgi->{id}'", "date desc, crtime desc", $limit, $offset);
my $nbn = scalar(@nnews);
my $lastpage = 0;
if ($nbn == 0)
{
    $page --;
    $offset -= $limit;
    if ($offset < 0) { $offset = 0; }
    @nnews = MN::News->getObjects("topic = '$cgi->{id}'", "date desc, crtime desc", $limit, $offset);
    $nbn = scalar(@nnews);
    $lastpage = 1;
}
if ($nbn < $limit)
{
    $lastpage = 1;
}

my $news;
my $num = $offset + 1;

print "<form method=\"POST\">\n";
print '<input type="hidden" name="page" value="'.$page.'">'."\n";
print '<input type="hidden" name="id" value="'.$cgi->{id}.'">'."\n";

my $pagebar = $cgi->pagebarCode($page, $lastpage);
if ($page)
{
    print $pagebar;
}

foreach $news (@nnews)
{
    print $news->getCode($num++,"hidden","hidden");
}

print $pagebar;

print $cgi->footerCode();
